## JJW 12 MARCH 2020 MODIFYING FOR MOTHER CORRELATION. Should make sense. put every mother-daughter pair both ways round 
## on axes as it were

every_nth <- function(x, nth, empty = TRUE, inverse = FALSE) 
{
  if (!inverse) {
    if(empty) {
      x[1:nth == 1] <- ""
      x
    } else {
      x[1:nth != 1]
    }
  } else {
    if(empty) {
      x[1:nth != 1] <- ""
      x
    } else {
      x[1:nth == 1]
    }
  }
}

library("egg")

## JJW 11 March 2020 going through this again for new graph formatting. may add mother correlation analysis in too. 

## sister lifetime correlation versus contemporaneously-dividing non-sisters.
## for starters don't even make a graph, just look to compare the mean lifetime offset (normalised by mean) of sisters
## to that of same-frame non-sister dividers. Could then look into making bins of frames later?

dir.create("mothers_lifetime_correlation")
load("time/roi_bt/lgRoiSmoothed.RData")
load("time/roi_bt/roiCellsBT.RData")
roiBothNests <- roiCellsBT %>% filter(roi == "anterior" | roi == "posterior")
roiHistoNoborder <- lgRoiSmoothed %>% filter(roi == "anterior")
roiAnterior <- roiCellsBT %>% filter(roi == "anterior")
roiPosterior <- roiCellsBT %>% filter(roi == "posterior")

## restrict to Anterior btw.
## SET BINSIZE PARAMETER
binsize <- 5

# comment out for mothers file

# sisters_lifetime_correlation <- cellinfoDB %>% filter(cell_id %in% roiAnterior$cell_id) %>% filter(appears_by == "Division") %>% filter(disappears_by == "Division") %>% select(cell_id,first_occ,last_occ,lineage_group)
# sisters_lifetime_correlation$lifetime <- sisters_lifetime_correlation$last_occ - sisters_lifetime_correlation$first_occ
# ## NOW AT THIS STAGE DEFINE THE MID_FRAME BEFORE MERGING WITH ITSELF, TO GET PAIRS THAT ARE NONSISTERS AND ARE IN DIFFERENT FRAMES BUT SAME BIN
# sisters_lifetime_correlation <- sisters_lifetime_correlation %>% mutate(mid_frame = binsize*floor(first_occ / binsize) + (binsize/2))
# 
# sisters_lifetime_correlation <- sisters_lifetime_correlation %>% dt.merge(sisters_lifetime_correlation,by="mid_frame", allow.cartesian=TRUE) %>% filter(!(cell_id.x == cell_id.y)) %>% select(-last_occ.x,-last_occ.y)
# ## label sisters
# sisters_lifetime_correlation$sisters <- (sisters_lifetime_correlation$lineage_group.x == sisters_lifetime_correlation$lineage_group.y)
# 
# ## GS FEEDBACK 28 NOVEMBER 2019. Wants to compute the covariance for sisters and nonsisters directly. 
# # One way to do this would be to calculate the correlation coefficient Cov(X,Y)/(sigma_X sigma_Y) where X, Y 
# # denote the lifetime of either a cell and its sister, or a cell and a randomly chosen non-sister as a control 
# # (we could do it as a function of time as you are currently doing I guess?)
# 
# # make a table with just the mean lifetime for each frame bin.
# meanlifetime_bin <- sisters_lifetime_correlation %>% group_by(mid_frame) %>% summarise(mean_lifetime = mean(lifetime.x),sd_lifetime = sd(lifetime.x))
# # merge this back to the original table.
# sisters_lifetime_correlation <- sisters_lifetime_correlation %>% dt.merge(meanlifetime_bin, by = "mid_frame")
# # compute covariance, normalised by square of std dev (right?) separately for sisters and non-sisters, grouping by bin. discard half of double-counted group
# cov_sisters <- sisters_lifetime_correlation %>% filter(sisters == TRUE) %>% filter(cell_id.y > cell_id.x) %>% group_by(mid_frame) %>% summarise(cov_norm = mean((lifetime.x-mean_lifetime)*(lifetime.y-mean_lifetime))/(mean(sd_lifetime)^2) )
# cov_nonsisters <- sisters_lifetime_correlation %>% filter(sisters == FALSE) %>% filter(cell_id.y > cell_id.x) %>% group_by(mid_frame) %>% summarise(cov_norm = mean((lifetime.x-mean_lifetime)*(lifetime.y-mean_lifetime))/(mean(sd_lifetime)^2) )
# 
# cov_plot <- cov_sisters %>% mutate(series="sisters") %>% rbind(cov_nonsisters %>% mutate(series="nonsisters"))
# 
# myplot <- ggplot(cov_plot, aes(16 + mid_frame*2.5/60, cov_norm, color=series)) +
#   geom_point(size = 2) +
#   geom_line(size = 1) +
#   theme(text = element_text(size = 18)) +
#   ylab(expression(paste("COV_norm of lifetime"))) +
#   xlab(expression(paste("Birth time (hr) (not time-aligned)"))) +
#   ggtitle("sister and nonsister lifetime correlation")
# pdf("sisters_lifetime_correlation/cov_plot.pdf")
# print(myplot)
# dev.off()

## second part of this: 
# Guillaume wants p(X,Y) where X and Y are lifetimes of sisters. I.e. a 2D probability distribution. 
# bin in both dimensions, and use RECIPROCAL DATA FOR SISTERS (i.e. i will end up with a symmetric plot I think).
# and the colour scale will be the density of points. 
# so first just get the sisters information and then restrict to div-div cells and attach the lifetimes. 


motherdaughterpairs_left <- cellinfoDB %>% select(cell_id,left_daughter_cell_id) %>% rename(mother = cell_id, daughter = left_daughter_cell_id) %>% na.omit()
motherdaughterpairs_right <- cellinfoDB %>% select(cell_id,right_daughter_cell_id) %>% rename(mother = cell_id, daughter = right_daughter_cell_id) %>% na.omit()
motherdaughterpairs <- rbind(motherdaughterpairs_left, motherdaughterpairs_right)
divdiv <- cellinfoDB %>% filter(appears_by == "Division" & disappears_by == "Division")
motherdaughterpairs <- motherdaughterpairs %>% filter(mother %in% divdiv$cell_id & daughter %in% divdiv$cell_id) 

## RESTRICT TO ANTERIOR
motherdaughterpairs <- motherdaughterpairs %>% filter(mother %in% roiAnterior$cell_id & daughter %in% roiAnterior$cell_id) 


# make a swapped version THINK THIS IS STILL VALID
temp1 <- motherdaughterpairs %>% select(mother) %>% rename(daughter = mother) 
temp2 <- motherdaughterpairs %>% select(daughter) %>% rename(mother = daughter) 
motherdaughterpairs_swapped <- temp2
motherdaughterpairs_swapped$daughter <- temp1$daughter
motherdaughterpairs <- rbind(motherdaughterpairs,motherdaughterpairs_swapped)
remove(motherdaughterpairs_swapped)

# add lifetime info.
motherdaughterpairs <- cellinfoDB %>% mutate(mother = cell_id, mother_lifetime = last_occ - first_occ) %>% select(mother, mother_lifetime) %>% dt.merge(motherdaughterpairs,by="mother")
motherdaughterpairs <- cellinfoDB %>% mutate(daughter = cell_id, daughter_lifetime = last_occ - first_occ) %>% select(daughter, daughter_lifetime) %>% dt.merge(motherdaughterpairs,by="daughter")

motherdaughterpairs <- motherdaughterpairs %>% mutate(mid_mother_lifetime = binsize*floor(mother_lifetime / binsize) + (binsize/2)) %>% mutate(mid_daughter_lifetime = binsize*floor(daughter_lifetime / binsize) + (binsize/2)) 

# need to somehow make it create Bins with ZERO count when no cell pairs exist for that bin.
# so lets make a fake table which lists one entry for each combination of mid_left_lifetime and mid_right_lifetime up to some limit, then combine it
# and then afterward subtract one from the count of all bins. 

dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_daughter_lifetime = dt)
dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_mother_lifetime = dt) %>% merge(dummy)
dummy$mother <- 1
dummy$daughter <- 1
dummy$mother_lifetime <- 1
dummy$daughter_lifetime <- 1

motherdaughterpairs_plus_dummy <- rbind(motherdaughterpairs,dummy)

# make the count unnormalised first.
pxy_motherdaughterpairs <- motherdaughterpairs_plus_dummy %>% group_by(mid_mother_lifetime,mid_daughter_lifetime) %>% summarise(count = n())
# substract ONE from each count to remove the dummy that I used to get zeros where there are no cell pairs
pxy_motherdaughterpairs$count <- pxy_motherdaughterpairs$count - 1
# normalise by total of count and by 'area' of a bin in frames^2 (IS THIS RIGHT?)
normalisation <- sum(pxy_motherdaughterpairs$count)*binsize^2
pxy_motherdaughterpairs$density <- pxy_motherdaughterpairs$count/normalisation
check <- sum(pxy_motherdaughterpairs$density)*binsize^2 #should be 1. 

## arrange nicely for CSV etc.
pxy_motherdaughterpairs <- pxy_motherdaughterpairs %>% arrange(mid_daughter_lifetime,mid_mother_lifetime)
# make a plot
myplot <- ggplot(pxy_motherdaughterpairs, aes(mid_daughter_lifetime*2.5/60, mid_mother_lifetime*2.5/60, fill=density)) + 
  geom_tile() +
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=3/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_blank(), # special for heatmaps element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
  ylab(expression(paste("Lifetime (hr)"))) +
  xlab(expression(paste("Lifetime (hr)"))) +
  scale_y_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE))
myplot <- set_panel_size(myplot,width  = unit(39*2/3, "mm"), #special square aspect
                         height = unit(39*2/3, "mm")) # special square aspect ratio for these heatmaps
ggsave("mothers_lifetime_correlation/pxy_mother_daughter_heatmap_anterior.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)


# make a CSV:
write.csv(pxy_motherdaughterpairs,file="mothers_lifetime_correlation/pxy_mother_daughter_heatmap_anterior.csv")
# 

### dont bother with this
# ## 3d surface plot??
# #install.packages("plotly")
# library("plotly")
# 
# #p <- plot_ly(z = ~volcano) %>% add_surface()
# p <- plot_ly(x = as.vector(pxy_sisters$mid_right_lifetime), y= as.vector(pxy_sisters$mid_left_lifetime), z = as.vector(pxy_sisters$density), type = 'mesh3d',intensity=as.vector(pxy_sisters$density)) 
# #p <- plot_ly(z = as.matrix(pxy_sisters %>% select(-count)), type = "surface")
# p
# #if (!require("processx")) install.packages("processx")
# library("processx")
# orca(p, "sisters_lifetime_correlation/plotly_test.png")
# 

# whatever.


# now want to either MEASURE or FIT the pxy as a bivariate normal distribution.
# http://mathworld.wolfram.com/BivariateNormalDistribution.html
# https://bioconductor.org/packages/release/bioc/vignettes/prada/inst/doc/norm2.pdf
# if (!requireNamespace("BiocManager", quietly = TRUE))
#   install.packages("BiocManager")
# BiocManager::install(version = "3.10")
#BiocManager::install(c("prada"))

# should be able to use prada as specified in the bioconductor vignette website above. I thiiiink I should apply it to the binned data
# not the raw data? could try both. 
# so start with sisters data but use the mid_right_lifetime and mid_left_lifetime
library("prada")

# meaning of fit output
# A list containing items mu (midpoint of distribution), S (covariance matrix), 
# p (density values for each data pair), sel (selection of data points), 
# scalefac (factor of standard deviations used for data selection), 
# data (x and y values of data points) and gate, an object of class gate containing the selection.
fit_input <- motherdaughterpairs %>% select(mid_daughter_lifetime,mid_mother_lifetime)
# try to perform the fit. scalefac is just for plotting purposes says how wide to show the ellipse which is an equiprobable contour
# it doesnt affect the fit values found
fit1 <- fitNorm2(as.vector(fit_input$mid_daughter_lifetime), y=as.vector(fit_input$mid_mother_lifetime), scalefac=1, method="covMcd", gateName = "fitNorm")
#fit2 <- fitNorm2(as.vector(fit_input$mid_right_lifetime), y=as.vector(fit_input$mid_left_lifetime), scalefac=2, method="covMcd", gateName = "fitNorm")
#plot the fit to see
plot1 <- plotNorm2(fit1, selection=TRUE, ellipse=TRUE, col = "dens")
dev.copy(png,"mothers_lifetime_correlation/fit_plot1.png")
dev.off()
#plotNorm2(fit2, selection=TRUE, ellipse=TRUE)

## ALSO plot from just the raw data, not the binned data.  think this is better
fit_input_raw <- motherdaughterpairs %>% select(daughter_lifetime,mother_lifetime)
fit1_raw <- fitNorm2(as.vector(fit_input_raw$daughter_lifetime), y=as.vector(fit_input_raw$mother_lifetime), scalefac=1, method="covMcd", gateName = "fitNorm")
#plot the fit to see
plot1_raw <- plotNorm2(fit1_raw, selection=TRUE, ellipse=TRUE, col = "dens")
dev.copy(png,"mothers_lifetime_correlation/fit_plot1_raw.png")
dev.off()

# now output the fit distribution properties in CSV. calculate basic properties of the fitted distribution.
write.csv(fit1_raw$mu,file="mothers_lifetime_correlation/fit_plot1_raw_mus.csv")
write.csv(fit1_raw$S,file="mothers_lifetime_correlation/fit_plot1_raw_S.csv")
rho <- fit1_raw$S[1,2]/( sqrt(fit1_raw$S[1,1]) * sqrt(fit1_raw$S[2,2]) )
sigmasq <- fit1_raw$S[1,1]
sigma <- sqrt(sigmasq)
mu <- fit1_raw$mu[[1]]
write.csv(rho, file="mothers_lifetime_correlation/fit_plot1_raw_rho.csv")
write.csv(sigmasq, file="mothers_lifetime_correlation/fit_plot1_raw_sigmasq.csv")

## now need to synthesise a bivariate normal distribution with this means, variance and covariance and plot it to see that it looks similar. 
library(MASS)
# how many samples to take to mimic the real data.
number_of_samples <- nrow(motherdaughterpairs)/2
synthetic_from_fit1_raw <- mvrnorm(number_of_samples, mu = fit1_raw$mu, Sigma = fit1_raw$S, 2) %>% as.data.frame() %>% rename(daughter_lifetime = x, mother_lifetime = y)
# now replicate the histogram heatmap making procedure on this data. need
# to do everything perhaps even starting from reciprocal-ising the data. 
# remove MASS now so that I CAN USE  dplyr properly
detach("package:prada", unload=TRUE)
detach("package:MASS", unload=TRUE)
# make a swapped version
temp1 <- synthetic_from_fit1_raw %>% select(mother_lifetime) %>% rename(daughter_lifetime = mother_lifetime) 
temp2 <- synthetic_from_fit1_raw %>% select(daughter_lifetime) %>% rename(mother_lifetime = daughter_lifetime) 
synthetic_from_fit1_raw_swapped <- temp2
synthetic_from_fit1_raw_swapped$daughter_lifetime <- temp1$daughter_lifetime
synthetic_from_fit1_raw <- rbind(synthetic_from_fit1_raw,synthetic_from_fit1_raw_swapped)
remove(synthetic_from_fit1_raw_swapped)

# add lifetime info
synthetic_from_fit1_raw <- synthetic_from_fit1_raw %>% mutate(mid_mother_lifetime = binsize*floor(mother_lifetime / binsize) + (binsize/2)) %>% mutate(mid_daughter_lifetime = binsize*floor(daughter_lifetime / binsize) + (binsize/2)) 

# need to somehow make it create Bins with ZERO count when no cell pairs exist for that bin.
# so lets make a fake table which lists one entry for each combination of mid_left_lifetime and mid_right_lifetime up to some limit, then combine it
# and then afterward subtract one from the count of all bins. 

dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_daughter_lifetime = dt)
dummy <- as.df(seq((binsize/2), 300+(binsize/2), by = binsize)) %>% rename(mid_mother_lifetime = dt) %>% merge(dummy)
dummy$mother_lifetime <- 1
dummy$daughter_lifetime <- 1

synthetic_from_fit1_raw_plus_dummy <- rbind(synthetic_from_fit1_raw,dummy)

# make the count unnormalised first.
pxy_synthetic_from_fit1_raw <- synthetic_from_fit1_raw_plus_dummy %>% group_by(mid_mother_lifetime,mid_daughter_lifetime) %>% summarise(count = n())
# substract ONE from each count to remove the dummy that I used to get zeros where there are no cell pairs
pxy_synthetic_from_fit1_raw$count <- pxy_synthetic_from_fit1_raw$count - 1
# normalise by total of count and by 'area' of a bin in frames^2 (IS THIS RIGHT?)
normalisation <- sum(pxy_synthetic_from_fit1_raw$count)*binsize^2
pxy_synthetic_from_fit1_raw$density <- pxy_synthetic_from_fit1_raw$count/normalisation
check <- sum(pxy_synthetic_from_fit1_raw$density)*binsize^2 #should be 1. 

## arrange nicely for CSV etc.
pxy_synthetic_from_fit1_raw <- pxy_synthetic_from_fit1_raw %>% arrange(mid_daughter_lifetime,mid_mother_lifetime)
# make a plot
myplot <- ggplot(pxy_synthetic_from_fit1_raw, aes(mid_daughter_lifetime*2.5/60, mid_mother_lifetime*2.5/60, fill=density)) + 
  geom_tile() +
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=3/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_blank(), # special for heatmaps element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
  ylab(expression(paste("Lifetime (hr)"))) +
  xlab(expression(paste("Lifetime (hr)"))) +
  scale_y_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE))
myplot <- set_panel_size(myplot,width  = unit(39*2/3, "mm"), #special square aspect
                         height = unit(39*2/3, "mm")) # special square aspect ratio for these heatmaps
ggsave("mothers_lifetime_correlation/pxy_mother_daughter_heatmap_synthetic_from_fit1_raw.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)

# myplot <- ggplot(pxy_synthetic_from_fit1_raw, aes(mid_right_lifetime*2.5/60, mid_left_lifetime*2.5/60, fill=density)) + 
#   geom_tile() +
#   theme(legend.position = "none") +
#   theme(text = element_text(size = 18)) +
#   scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
#   ylab(expression(paste("Sister lifetime (hr)"))) +
#   xlab(expression(paste("Sister lifetime (hr)"))) +
#   ylim(0,8.5) +
#   xlim(0,8.5) 
# pdf("sisters_lifetime_correlation/pxy_heatmap_synthetic_from_fit1_raw.pdf")
# print(myplot)
# dev.off()

# make a CSV:
write.csv(pxy_synthetic_from_fit1_raw,file="mothers_lifetime_correlation/pxy_mother_daughter_heatmap_synthetic_from_fit1_raw.csv")

## try making a smooth heatmap of the completely ANALYTIC i.e. not sampled distribution.
# https://www.rdocumentation.org/packages/emdbook/versions/1.3.11/topics/dmvnorm
# https://stackoverflow.com/questions/26106086/2d-normal-pdf-with-ggplot-and-r
#install.packages("mvtnorm")
library("mvtnorm")
#mvtnorm::dmvnorm()

#                                                  -----------------------------------------------------must change parameters here!1
pxy_analytic_from_fit1_raw <- as.df(seq((binsize/2), 300+(binsize/2), by = 1)) %>% rename(mid_daughter_lifetime = dt)
pxy_analytic_from_fit1_raw <- as.df(seq((binsize/2), 300+(binsize/2), by = 1)) %>% rename(mid_mother_lifetime = dt) %>% merge(pxy_analytic_from_fit1_raw)

## _______________________________________________________________________________________________________________ANALYTIC MANUAL PARAMETER SETTING!!!!
pxy_analytic_from_fit1_raw <- pxy_analytic_from_fit1_raw  %>% mutate(density = mvtnorm::dmvnorm(x=matrix(c(mid_mother_lifetime,mid_daughter_lifetime),ncol=2),mean=matrix(c(104,104),ncol=2),sigma=matrix(c(463.5,-31.5,-31.5,463.5),ncol=2) ) )
## _______________________________________________________________________________________________________________ANALYTIC MANUAL PARAMETER SETTING!!!!


myplot <- ggplot(pxy_analytic_from_fit1_raw, aes(mid_daughter_lifetime*2.5/60, mid_mother_lifetime*2.5/60, fill=density)) + 
  geom_tile() +
  theme(legend.direction="horizontal",legend.position="none", 
        legend.title = element_blank(), aspect.ratio=3/3, 
        text = element_text(size = 10), panel.grid.major.x = element_blank(), 
        panel.grid.minor.x = element_blank(),
        panel.grid.minor.y = element_blank(), panel.border = element_blank(), 
        axis.line = element_line(colour = "black",size=0.6), 
        panel.grid.major.y = element_blank(), # special for heatmaps element_line(colour = "grey", linetype = "solid", size=0.4), 
        axis.text=element_text(size=10, colour = "black"), 
        legend.text=element_text(size=10, colour = "black"), 
        axis.ticks=element_line(size=0.6,colour="black")) +
  scale_fill_gradientn(colors  = jet.colors(7),limits=c(0,0.0012)) +
  ylab(expression(paste("Lifetime (hr)"))) +
  xlab(expression(paste("Lifetime (hr)"))) +
  scale_y_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE)) +
  scale_x_continuous(limits=c(0,8.5), breaks=seq(0,8,1), expand = c(0,0), labels = every_nth(seq(0,8,1), 2, inverse = TRUE))
myplot <- set_panel_size(myplot,width  = unit(39*2/3, "mm"), #special square aspect
                         height = unit(39*2/3, "mm")) # special square aspect ratio for these heatmaps
ggsave("mothers_lifetime_correlation/pxy_heatmap_analytic_from_fit1_raw.pdf", plot = myplot, device="pdf",
       scale=1, width = 103*0.55, height=103*0.55, units = "mm",
       dpi = 1000, limitsize = TRUE,  useDingbats=FALSE)




